# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Phoenix87 <phoenix1987@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import gtk

from gtumbler_lib.helpers import get_builder

import gettext
from gettext import gettext as _
gettext.textdomain('gtumbler')

class ProgressDialog(gtk.Dialog):
    __gtype_name__ = "ProgressDialog"

    def __new__(cls, data = None):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated ProgressDialog object.
        """
        builder = get_builder('ProgressDialog')
        new_object = builder.get_object('progress_dialog')
        new_object.finish_initializing(builder)
        return new_object

    def finish_initializing(self, builder):
        """Called when we're finished initializing.

        finish_initalizing should be called after parsing the ui definition
        and creating a ProgressDialog object with it in order to
        finish initializing the start of the new ProgressDialog
        instance.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.ui = builder.get_ui(self)

	def __enter__(self):
		return self
		
	def __exit__(self, exc_type, exc_value, traceback):
		self.destroy()
		return False

    def __init__(self, thread = None):
        self.thread = thread
        self.steps = 0
        self.current_step = 0
        self.max = 0
        self.initial_Frac = 0
       
    def start(self):
        self.thread.start()
        return self.run()
        
    def stop(self):
        self.thread.stop()
        
### BEGIN LOCAL HELPERS

    def get_fraction(self):
        return self.ui.pb_task.get_fraction()

    def set_current_task(self, task):
        self.ui.lbl_current_task.set_text(task)
        
    def pulse(self):
        self.ui.pb_task.pulse()
        
    def set_fraction(self, frac):
        self.ui.pb_task.set_fraction(frac)

    def set_max(self, fl):
        self.max = fl

    def set_steps(self, n):
        self.steps = n
        self.current_step = 0
        self.initial_frac = self.get_fraction()
        
    def stepit(self):
        self.current_step += 1
        self.set_fraction(self.initial_frac + float(self.current_step) / self.steps * self.max)
        
    def spinner(self, spin):
		self.ui.spinner.set_visible(spin)
		self.ui.spinner.start() if spin else self.ui.spinner.stop()
		
### END LOCAL HELPERS

### BEGIN SIGNAL HANDLERS

    def on_btn_cancel_clicked(self, widget, data=None):
        """The user has elected cancel changes.

        Called before the dialog returns gtk.RESPONSE_CANCEL for run()
        """
        pass


### END SIGNAL HANDLERS
