# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Phoenix87 <phoenix1987@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import optparse

import gettext
from gettext import gettext as _
gettext.textdomain('gtumbler')

import gtk
import gobject

from gtumbler import GtumblerWindow

from gtumbler_lib import set_up_logging, preferences, get_version
from gtumbler.session import Session

def parse_options():
    """Support for command line options"""
    parser = optparse.OptionParser(version="%%prog %s" % get_version())
    parser.add_option(
        "-v", "--verbose", action="count", dest="verbose",
        help=_("Show debug messages (-vv debugs gtumbler_lib also)"))
    (options, args) = parser.parse_args()

    set_up_logging(options)

def main():
    'constructor for your class instances'
    parse_options()

    # preferences
    # set some values for our first session
    # TODO: replace defaults with your own values
    default_preferences = {
    'cb_box0'					: '#A020F0',
    'cb_box1'					: '#FF0000',
    'cb_box2'					: '#0000FF',
    'cb_box3'					: '#00FF00',
    'cb_box4'					: '#4D4D4D',
    
    'cbo_editor'				: 0,
    'cbo_compatibility'			: 2,

    'chk_convert'				: True,
    'chk_create_copy'			: True,
    'chk_crop_create_copy'		: True,
    'chk_display_path'			: True,
    'chk_open_cat'				: False,
    
    'rdo_viewer_default'		: True,
    'rdo_viewer_custom'			: False,
    
    'txt_other_tool'			: '',
    'txt_tool_args'				: '',
    'txt_viewer_custom'			: '',
    }
    preferences.update(default_preferences)
    # user's stored preferences are used for 2nd and subsequent sessions
    preferences.db_connect()
    preferences.load()

    # Run the application.
    gobject.threads_init()
    gtk.gdk.threads_init()
    window = GtumblerWindow.GtumblerWindow()
    Session(window)
    window.show()
    gtk.gdk.threads_enter()
    gtk.main()
    gtk.gdk.threads_leave()
    
    preferences.save()
