# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Phoenix87 <phoenix1987@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import subprocess

def execute(cmd, terminal=True):
	return subprocess.Popen(cmd, shell=terminal, stdout=subprocess.PIPE).communicate()[0][:-1]

def run(cmd, terminal=True):
	return subprocess.Popen(cmd, shell=True)

def get_mimetype(f):
	return execute('file -b --mime-type "%s"' % f)

def gnome_open(cmd):
	return run('gvfs-open "%s"' % cmd)

def pdfedit(args, filename):
	return run('pdfedit %s "%s"' % (args, filename))
	
def ps2pdf(src, dest, comp = '1.4'):
	return execute('ps2pdf -dCompatibility=%s "%s" "%s"' % (comp, src, dest))

def xournal(args, filename):
	return run('xournal %s "%s"' % (args, filename))
