from gtumbler.session import Session

class Command(object):
    """This class provides an abstraction for the Command pattern.
    The required methods are *do* and *undo*. If not overridden by
    the subclass, the *redo* method will always refer to the *do*
    method."""
    
    def __init__(self):
        if not getattr(self, 'redo', None): self.redo = self.do
        s = Session()
        s.do(self)
    
    def do(self):
        raise NotImplementedError("You must implement a do() method" )

    def undo(self):
        raise NotImplementedError("You must implement an undo() method" )
